#ifndef HH_CLIENT
#define HH_CLIENT

#include "tesla/async.hh"

class client : protected async {
protected:
    int fd;
    bool messages_enabled;
    int msg_fd_remote;
    int msg_fd;
    bool inessential;

public:
    client(int _fd) : async(_fd), fd(_fd), messages_enabled(false),
		      msg_fd_remote(-1), msg_fd(-1),
		      inessential(false)
    {
	set_ractive(true);
    }

    virtual ~client() {
	close(fd);
	if (msg_fd_remote >= 0) close(msg_fd_remote);
	if (msg_fd >= 0) close(msg_fd);
    }

    virtual void ravail();

    bool are_messages_enabled() { return messages_enabled; }
    int get_msg_fd() { return msg_fd; }
    bool is_inessential() { return inessential; }

protected:
    void set_inessential(bool i) { inessential = i; }
};

#endif
